const state = {
    journals: {
        default: [],
        values: this.default
    },
    selectedJournal: {
        default: null,
        value: null
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    journals(state) {
        return state.journals.values
    },
    /**
     * 
     * @param {*} state 
     */
    selectedJournal(state) {
        return state.selectedJournal.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setJournals(state, payload) {
        state.journals.values = [...payload]
        state.selectedJournal.value = state.journals.values.find(item => item.type === 'cash')
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setSelectedJournal(state, payload) {
        state.selectedJournal.value = payload
    },  
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    selectJournal({ commit }, payload) {
        commit('setSelectedJournal', payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}