const state = {
    suppliers: {
        default: [],
        values: []
    },
    filteredSuppliers: {
        default: [],
        values: []
    },
    supplierSelected: {
        default: null,
        value: null
    },
    addSupplier: {
        default: false,
        value: false
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    suppliers(state) {
        return state.suppliers.values
    },
    /**
     * 
     * @param {*} state 
     */
    visibleSuppliers(state) {
        return state.filteredSuppliers.values.length === 0 ? state.suppliers.values : state.filteredSuppliers.values
    },
    /**
     * 
     * @param {*} state 
     */
    supplierSelected(state) {
        return state.supplierSelected.value
    },
    /**
     * 
     * @param {*} state 
     */
    addSupplier(state) {
        return state.addSupplier.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setSuppliers(state, payload) {
        state.suppliers.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setSupplierSelected(state, payload) {
        state.supplierSelected.value = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setFilteredSuppliers(state, payload) {
        state.filteredSuppliers.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     */
    setAddSupplier(state, payload) {
        state.addSupplier.value = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    selectSupplier({ commit }, payload) {
        console.log(payload)
        // commit('setSupplierSelected', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    filterSuppliers({ commit }, payload) {
        commit('setFilteredSuppliers', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    addSupplier({ commit }) {
        commit('setAddSupplier', true)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    showSupplierForm({ commit }) {
        console.log('show')
    },
    /**
     * 
     * @param {*} param0 
     */
    pushSupplier({ commit, dispatch }) {
        console.log('push')
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}